Tired of dozens of copies of openjdk-6-src-b23-05_jul_2011.tar.gz? Here's a suggestion...

Andrew Haley aph at redhat.com
Thu Oct 20 10:31:49 PDT 2011


I've been looking at the way we look for drops tarballs and download
them.  It's usually pointless for me, since I almost always have a
copy of the tarballs on the system already.

I think the best way to do it is to try, in order:

  if the file is OK, don't do anything

  locate a copy of the file on the local system and hardlink to it

  locate a copy of the file on the local system and copy it

  download it from the web server

That's what this script does, and as well as being much faster it
saves disk space.  It'll need tidying up, of course, but I think the
idea is sound.  Comments?

Andrew.


--- a/Makefile.am	Thu Oct 20 16:14:29 2011 +0100
+++ b/Makefile.am	Thu Oct 20 18:28:45 2011 +0100
@@ -888,15 +891,7 @@
 if USE_ALT_OPENJDK_SRC_ZIP
 	ln -sf $(ALT_OPENJDK_SRC_ZIP) $(OPENJDK_SRC_ZIP)
 else
-	if ! echo "$(OPENJDK_SHA256SUM)  $(OPENJDK_SRC_ZIP)" \
-	  | $(SHA256SUM) --check ; \
-	then \
-	  if [ -e $(OPENJDK_SRC_ZIP) ] ; \
-	  then \
-	    mv $(OPENJDK_SRC_ZIP) $(OPENJDK_SRC_ZIP).old ; \
-	  fi ; \
-	  $(WGET) $(OPENJDK_URL)$(OPENJDK_SRC_ZIP) -O $(OPENJDK_SRC_ZIP); \
-	fi
+	./find-file $(OPENJDK_SRC_ZIP) $(OPENJDK_SHA256SUM) $(OPENJDK_URL)
 endif
 endif
 endif
diff -r 13009e3bdf2c find-file
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/find-file	Thu Oct 20 18:28:45 2011 +0100
@@ -0,0 +1,40 @@
+#!/bin/bash
+
+# USAGE find-file /path/to/dest/file/name sha256sum url
+
+files=$(locate `basename $1`)
+
+if echo "$2  $1" | sha256sum --check
+then
+    exit 0
+fi
+
+if [ -e "$1" ]
+then
+    mv -f "$1" "$1.old"
+fi
+
+for file in $files
+do
+    if (ln -f "$file" $1 && chown `whoami` $1 && echo "$2  $1" | sha256sum --check)
+    then
+	exit 0
+    fi
+    rm -f $1
+done
+
+for file in $files
+do
+    if (cp "$file" $1 && echo "$2  $1" | sha256sum --check)
+    then
+	exit 0
+    fi
+    rm -f $1
+done
+
+if wget "$3$1" -O $1
+then
+    exit 0
+fi
+
+exit 1



More information about the distro-pkg-dev mailing list